/*
** Copyright 2008-11 ScorchOS Developers
** See doc/License.txt for terms of use.
**
** PS/2 Driver & Keyboard Scancode Decoder 
** Improved by Primis
*/

#include <system.h>
#include <kb.h>

/// These are static Variables, They are the control lines of the keyboard;
    /// shift, caps_flag, ctrl, ect.

unsigned char shift_flag = 0;            // shift_flag Key Status 
unsigned char ctrl = 0;             // Ctrl Key Status
unsigned char alt = 0;              // Alt Key Status 
unsigned char caps_flag = 0;             // caps_flag Lock Status
unsigned char num = 0;              // Num Lock Status 
//unsigned char keyBuff[257];         // Keybuffer 
//volatile unsigned char keyBuffEnd = 0;  // The Last key in the buffer
unsigned char asciiCode;            // The ASCII Code
unsigned char leds = 0;             // The Three LED's on the keyboard.
unsigned char kbScanCodes[512] =    
    /// Keyboard character maps (Look-up table)
{					
	0, 27, '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '-', '=', '\b',
	'\t', 'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '[' , ']', '\n', 0,
	'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', ';', '\'', '`', 0,
	'\\', 'z', 'x', 'c', 'v', 'b', 'n', 'm', ',', '.', '/', 0,
	'*', 0, ' ', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, '-', 0, 0, 0, '+', 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	/* shift_flaged */
	0, 27, '!', '@', '#', '$', '%', '^', '&', '*', '(' , ')', '_' , '+', '\b',
	'\t', 'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', '{' , '}', '\n', 0,
	'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', ':', '"', '~', 0,
	'|', 'Z', 'X', 'C', 'V', 'B', 'N', 'M', '<', '>', '?', 0,
	'*', 0, ' ', 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, '7', '8', '9', 0, '4', '5', '6', 0,
	'1', '2', '3', '0', 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	/* caps_flag, Normal */
	0, 27, '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '-', '=', '\b',
	'\t', 'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', '[' , ']', '\n', 0,
	'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', ';', '\'', '`', 0,
	'|', 'Z', 'X', 'C', 'V', 'B', 'N', 'M', ',', '.', '/', 0,
	'*', 0, ' ', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, '-', 0, 0, 0, '+', 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	/* caps_flag, shift_flaged */
	0, 27, '!', '@', '#', '$', '%', '^', '&', '*', '(' , ')', '_' , '+', '\b',
	'\t', 'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '{' , '}', '\n', 0,
	'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', ':', '"', '~', 0,
	'\\', 'z', 'x', 'c', 'v', 'b', 'n', 'm', '<', '>', '?', 0,
	'*', 0, ' ', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, '-', 0, 0, 0, '+', 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

#define  KB_SIZE ( 1 << 5 )
char KEY_BUF[KB_SIZE];
int volatile KB_IN=1;
int volatile KB_OUT=0;

void KB_CLR()
{ KB_IN=1; KB_OUT=0;
}

unsigned kbhit(){ return ( (KB_IN-KB_OUT-1) & (KB_SIZE-1) );}

void FlushBuffer()
    /// There is a hardware buffer for storing keypresses just incase you
    /// Wanted to use polling instead of interrupts, we have to clear this
    /// Before we set up the keyboard so random crap doesnt show up in the
    /// Software buffer
{
	unsigned temp;
	do
	{
		temp = inb(0x64);
		if((temp & 0x01) != 0) 
		{
			(void)inb(0x60);
			continue;
		}
	} while((temp & 0x02) != 0);
}


int kb_special(unsigned char key)
{
	static int specKeyUp = 1;	// Is a key already been or being pressed?
	switch(key) 
	{
		case 0x36: // R-shift_flag down
		case 0x2A: // L-shift_flag down
			shift_flag = 1;
			break;
		case 0xB6: // R-shift_flag up
		case 0xAA: // L-shift_flag up
			shift_flag = 0;
			break;
		case 0x1D: // Control down
			ctrl = 1;
			break;
		case 0x9D: // Control up
			ctrl = 0;
			break;
		case 0x38: // Alt down
			alt = 1;
			break;
		case 0xB8: // Alt up
			alt = 0;
			break;
		case 0x3A: // caps_flag down
			if(specKeyUp == 1) 
			{
				caps_flag = !caps_flag;
				UpdateLeds(CapsLock);
				specKeyUp = 0;
			}
			break;
		case 0x45: // Num down
			if(specKeyUp == 1)
			{
				num = !num;
				UpdateLeds(NumLock);
				specKeyUp = 0;
			}
			break;
		case 0x46: // Scroll down
			if(specKeyUp == 1)
			{
				num = !num;
				UpdateLeds(ScrollLock);
				specKeyUp = 0;
			break;
			} // ABORT();
			break;
		case 0xBA: // caps_flag Up
		case 0xC5: // Num Up
		case 0xC6: // Scroll Up
			specKeyUp = 1;
			break;
		case 0xE0:
			break;
		default:
			return(0);
	}
	return (1);
}


void keyboard_handler(struct regs *r)
    /// Get keyboard input during the keyboard interrupt
    /// Convert the scancode into ascii data.
{
	unsigned char scanCode;
	scanCode = inb(0x60);
	unsigned char asciiCode;
	outb(0x3f8,scanCode);
	
	if(!(kb_special(scanCode) | (scanCode >= 0x80)))
	{
		if(shift_flag)		//Determine key that has been pressed
		{
			if(!caps_flag)
			{
				asciiCode = kbScanCodes[scanCode + 128];
			}
			else
			{
				asciiCode = kbScanCodes[scanCode + 384];
			}
		}
		else
		{
			if(!caps_flag)
			{
				asciiCode = kbScanCodes[scanCode];
			}
			else
			{
				asciiCode = kbScanCodes[scanCode + 256];
			}
		}

			KEY_BUF[ (KB_IN++) & (KB_SIZE-1) ] = asciiCode;
	}
}

char getch()
    /// Get a charecter from the stdin
{
	while(!kbhit())
	{ 	__asm__ __volatile__ ("hlt");  };
   return  KEY_BUF[ (++KB_OUT) & (KB_SIZE-1) ];

}

void waitKey()
    /// Wait for a keypress on the keyboard
{
	FlushBuffer();  // Empty the Buffer of erratic data
	while (getch() == 0);
}



void UpdateLeds(char led)
    /// Keyboards have LED's for locks, update them so they match what the
    /// States of the keyboard are.
{
	if(led == 0)
	{
		leds = 0;
	}
	else
	{
	if (leds == (leds|led))	        // If led is already on
		{
			leds = leds^led;	    // We turn the led off
		}
		else
		{
			leds = leds | led;	    // Else, turn led on
		}
}
	while((inb(0x64) &2) !=0);  // Loop until zero
	outb(0x60, 0xED);
	while((inb(0x64) &2) !=0 ); // Loop until zero
	outb(0x60, leds);			// Update led status register
}

void init_keyboard()
{
    register_interrupt_handler(IRQ1, &keyboard_handler);
}
