/* CakeOS */
/* Main kernel entry point */
#include <system.h>

/**
   WIP's:
         - cd command
              - symlink support needed
         - kill command
         - fix tasks (max is 129 atm)
              - heap is issue
              - kfree() doesn't work
**/

u32int initial_esp;
extern u32int placement_address;

extern unsigned g_wd, g_ht;

//extern unsigned fb_seg;
extern u8int double_buffer;

extern page_directory_t *current_directory;

extern heap_t* kheap;

//extern window_t current_window;

/* Prototypes of tasks */
void hello_world();
void test_userland();
void sysidle();

void test_dynamic();
void amain();
void init_keyboard();
/* Drivers */
//void init_vga();
void shell();

#ifndef __stack_chk_fail

void __stack_chk_fail(void){}

#endif


#define SPORT 0x3f8   /* COM1 */

int is_transmit_empty() {
   return inb(SPORT + 5) & 0x20;
}
 
void write_serial(char a) {
   while (is_transmit_empty() == 0);
 
   outb(SPORT,a);
}


     u32int initrd_location;
     u32int initrd_end;

void kmain(struct multiboot *mbd, u32int initial_stack)
{
     initial_esp = initial_stack; //Set up for stack switch
     
   outb(SPORT + 4, 0x01);
   outb(SPORT + 3, 0x80);
   outb(SPORT + 0, 0x01);
   outb(SPORT + 1, 0x00);
   outb(SPORT + 3, 0x03);
   outb(SPORT + 1, 0x00);
   outb(SPORT + 2, 0x01);


     init_descriptor_tables();
     kprintf("IDT/GDT initialised...\n");
     
     init_timer(100);
     kprintf("CMOS timer initialised to 100hz...\n");
     
     //Make sure placement_address doesn't destroy
     //the location of our initrd and other modules
     initrd_location = *((u32int*)mbd->mods_addr);
     initrd_end = *(u32int*)(mbd->mods_addr+4);
     placement_address = initrd_end;
     
     //Initialise paging with the memory amount reported by GRUB
     u32int memsz = ((mbd->mem_lower + mbd->mem_upper) * 1024); //Bytes
// mmo     init_paging(memsz);
//     init_paging(0x1f00000);
//     kprintf("Paging initialised with %dMB of memory...\n",(memsz/1024/1024));
     
     u32int malloc_test = kmalloc(100);
     if(malloc_test != 0)
     {
          kprintf("MMU working as expected:\n\tMemory test assigned 100 bytes at 0x%x...\n",malloc_test);
          kfree((void*)malloc_test);
     }
     else
     puts("MMU failed test...\n");
     
     puts("Initialising PCI bus...\n");
     init_pci();
     
     init_keyboard();
     kprintf("PS/2 keyboard initialised...\n");
     
     sti(); //Let multitasking happen baby!
     
	amain();
 	while(1) {	monitor_put(getch());	}

}

void sysidle()
{
     set_task_priority(PRIO_LOW);
     for(;;)     __asm__ __volatile__ ("nop");
}

