purpose: OHCI USB Controller probe

hex

: probefth

s" : probe-root-hub-port" eval  ( port -- )
s"    dup disable-old-nodes" eval				( port )
s"    dup hc-rh-psta@ 1 and 0=  if drop exit  then" eval	( port )

   \ Reset the port to determine the speed
s"    dup reset-port" eval					( port )
s"    dup hc-rh-psta@ 200 and  if  speed-low  else  speed-full  then" eval	( port speed )

   \ hub-port and hub-speed are irrelevant for OHCI (USB 1.1)
s"    0 0" eval						( port speed hub-port hub-dev )

   \ Execute setup-new-node in root context and make-device-node in hub node context
s"    setup-new-node  if  execute  then	;" eval	( port dev xt )


s" false value ports-powered?" eval

s" : #ports  ( -- n )  hc-rh-desa@ h# ff and  ;" eval

\ This version powers all the ports at once
s" : power-ports" eval  ( -- )
s"    hc-rh-desa@  dup h# 200  and  0=  if" eval
      \ ports are power switched
s"       hc-rh-stat@ h# 10000 or hc-rh-stat!" eval	\ power all ports
s"       hc-rh-desb@ d# 17 >> over h# ff and 0  ?do" eval
s"          dup 1 i << and  if" eval
s"             i hc-rh-psta@  h# 100 or i hc-rh-psta!" eval	\ power port
s"          then" eval
s"       loop  drop" eval
s"    then  drop" eval
s"    potpgt 2* ms" eval			\ Wait until powergood

   \ Setup PowerOnToPowerGoodTime and OverCurrentProtectionMode
s"    hc-rh-desA@  h# 00ffffff and  potpgt d# 24 lshift or" eval
s"    h# 800 or   hc-rh-desA!" eval	\ per-port over-current status

s"    true to ports-powered? ;" eval

\ mmo [ifdef] notdef
\ This version powers the ports in a staggered fashion to reduce surge current
s" : stagger-power" eval  ( -- )
s"    hc-rh-desa@  h# 200 and  0=  if" eval               ( )
s"       hc-rh-desa@ h# 100 or hc-rh-desa!" eval	\ Individual power switching mode
s"       #ports  h# f min" eval                           ( numports )
s"       1 over lshift 1-" eval                           ( numports bitmask )
s"       d# 17 lshift  hc-rh-desb@ or  hc-rh-desb!" eval  ( numports )
s"       0  ?do" eval
s"          i hc-rh-psta@  h# 100 or i hc-rh-psta!" eval  \ power port
s"          d# 10 ms" eval            \ Stagger to lower surge current
s"       loop" eval
s"    then" eval
s"    potpgt 2* ms" eval			\ Wait until powergood

   \ Setup PowerOnToPowerGoodTime and OverCurrentProtectionMode
s"    hc-rh-desA@  h# 00ffffff and  potpgt d# 24 lshift or" eval
s"    h# 800 or   hc-rh-desA!" eval	\ per-port over-current status

s"    true to ports-powered? ;" eval
\ [then]

s" : probe-root-hub" eval  ( -- )
   \ Power on ports
   \ ports-powered? 0=  if  power-ports  then
s"    0 hc-rh-psta@ h# 100 and  if" eval
 "       "" wait-usb-power"" $find  if  execute  else  2drop  then" eval
s"    else" eval
s"       power-ports" eval
s"    then" eval

   \ Set active-package so device nodes can be added and removed
s"    my-self ihandle>phandle push-package" eval

s"    alloc-pkt-buf" eval
s"    #ports 0  ?do" eval
s"       i hc-rh-psta@ 30000 and  if" eval
s"          i ['] probe-root-hub-port catch  if" eval
 " 	    drop ."" Failed to probe root port "" i u. cr" eval
s"          then" eval
s"          30000 i hc-rh-psta!" eval			\ Clear change bits
s"       else" eval
s"          i port-is-hub?  if" eval     ( phandle )     \ Already-connected hub?
s"             reprobe-hub-node" eval                    \ Check for changes on its ports
s"          then" eval
s"       then" eval
s"    loop" eval
s"    free-pkt-buf" eval

 s"   pop-package ;" eval
\ s"   pop-package ; debug probe-root-hub" eval

s" : open" eval  ( -- flag )
s"    parse-my-args" eval
s"    open-count 0=  if" eval
s"       map-regs" eval
s"       first-open?  if" eval
s"          false to first-open?" eval
s"          reset-usb" eval
s"          init-struct" eval
s"          init-ohci-regs" eval
s"       then" eval
s"       alloc-dma-buf" eval
s"    then" eval
s"    probe-root-hub" eval
s"    open-count 1+ to open-count" eval
\ s"    true ;" eval
s"    true ; debug open " eval

s" : close" eval  ( -- )
s"    open-count 1- to open-count" eval
s"    end-extra" eval
s"    open-count 0=  if  free-dma-buf unmap-regs  then ;" eval
;
